# Feature List Couper 1.x

## Connectivity & Routing

* HTTP request routing/forwarding (proxy mode)
* Virtual endpoints
* Timeouts
* Header enrichment
* Path based routing
* URL manipulation
* Header manipulation
* Configurable upstream connection pools with queues
* Configurable upstream TLS certificate validation
* Error Handling

## Authorization & Authentication

* Basic authentication
* JWT Validation
* JWT header passing
* Upstream authorization
* JWT signing
* SAML
* OAuth 2.0 client credentials

## Security

* Upstream OpenAPI3 schema validation
* CORS
* Request size limiting

## Observability

* Request context IDs
* Logging
* Health check

## SPA & Web Serving

* Static file serving
* SPA bootstrap document serving

## Configurability & Deployment

* HCL based configuration
* Env Variables
* Integrates with Kubernetes
